<html>
<head>
<title>Doc :: hash :: algorithm, generate, ...</title>
</head>
<body>
<a href="../index.adp">up</a><br>
<h1>Hash</h1>
<h2>Available algorithm</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash algorithms</font></tt></td></tr>
<tr><td align="right">result:</td><td>list of available hash algorithms</td></tr>
<tr><td align="right">example:</td><td>[ns_mhash hash algorithms]=<%=[ns_mhash hash algorithms]%></td></tr>
</table>

<h2>create new HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash new <i>algorithm_name</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>algorithm_name</i> - name of hash algorithm: MD5, SHA1, ... </td></tr>
<tr><td align="right">result:</td><td>HASH object using in other commands</td></tr>
<tr><td align="right">example:</td><td>[ns_mhash hash new MD5]</td></tr>
</table>

<h2>destroy HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash destroy <i>hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>hash_id</i> - id of HASH object generated by new command (above) </td></tr>
<tr><td align="right">result:</td><td>destroy HASH object without any output</td></tr>
<tr><td align="right">example:</td><td>ns_mhash hash destroy $hashid</td></tr>
</table>

<h2>end/print HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash end ?-bin|-base64? <i>hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td>
<i>hash_id</i> - id of HASH object generated by new command (above)<br>
?-bin|-base64? - type of output format for generated hash string :: default: hexadecimal string; binary (TclByteArray): -bin; binary base64 encoded: -base64<br>
</td></tr>
<tr><td align="right">result:</td><td>return output hash string and destroy HASH object</td></tr>
<tr><td align="right">example:</td><td>set out [ns_mhash hash end -base64 $hashid]</td></tr>
</table>

<h2>copy HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash copy <i>hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>hash_id</i> - id of HASH object generated by new command (above)</td></tr>
<tr><td align="right">result:</td><td>copy of HASH object</td></tr>
<tr><td align="right">example:</td><td>set hashid2 [ns_mhash hash copy $hashid]</td></tr>
</table>

<h2>update HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash update <i>hash_id</i> <i>string</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>hash_id</i> - id of HASH object generated by new command (above)<br>
<i>string</i> - string you want to hash</td></tr>
<tr><td align="right">result:</td><td>update HASH object by string. You can use this repeatedly</td></tr>
<tr><td align="right">example:</td><td>ns_mhash hash update $hashid "Hello world"</td></tr>
</table>

<h2>detach HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash detach <i>hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>hash_id</i> - id of HASH object generated by new command (above)</td></tr>
<tr><td align="right">result:</td><td>detach HASH object from Tcl interpreter. You can you with nsv_* for share HASH object.</td></tr>
<tr><td align="right">example:</td><td>
set detachid [ns_mhash hash detach $hashid]<br>
nsv_set test test $detachid
</td></tr>
</table>

<h2>attach HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash attach <i>detach_hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>detach_hash_id</i> - detach id of HASH object generated by detach command (above)</td></tr>
<tr><td align="right">result:</td><td>attach HASH object to Tcl interpreter for next using. You can you with nsv_* for share HASH object.</td></tr>
<tr><td align="right">example:</td><td>
set detachid [nsv_get test test]<br>
set hashid [ns_mhash hash attach $detachid]
</td></tr>
</table>

<h2>serialize HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash serialize <i>hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>hash_id</i> - id of HASH object generated by new command (above)</td></tr>
<tr><td align="right">result:</td><td>serialize HASH object and destroy this HASH object. The result is base64 encoded HASH object. You can you with nsv_* for share HASH object or save to file|database.</td></tr>
<tr><td align="right">example:</td><td>
set serializeobj [ns_mhash hash serialize $hashid]<br>
nsv_set test test $serializeobj
</td></tr>
</table>

<h2>unserialize HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hash unserialize <i>serialize_hash_str</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>serialize_hash_str</i> - serialize HASH object  generated by serialize command (above)</td></tr>
<tr><td align="right">result:</td><td>create HASH object from serialize string. You can you with nsv_* for share HASH object or save to file|database.</td></tr>
<tr><td align="right">example:</td><td>
set serializeobj [nsv_get test test]<br>
set hashid [ns_mhash hash unserialize $serializeobj]
</td></tr>
</table>



<h2>Full samples:</h2>
<h3>simple without output</h3>
<pre>
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello world"
ns_mhash hash destroy $td
</pre>
<br>
<h3>simple with hash string (base64)</h3>
<pre>
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello world"
set out [ns_mhash hash end -base64 $td]
ns_adp_puts $out
</pre>
result: <%
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello world"
set out [ns_mhash hash end -base64 $td]
ns_adp_puts $out
%>
<br>
<br>
<h3>simple with hash string (hexadecimal)</h3>
<pre>
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello world"
set out [ns_mhash hash end $td]
ns_adp_puts $out
</pre>
result: <%
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello world"
set out [ns_mhash hash end $td]
ns_adp_puts $out
%>
<br>
<br>
<h3>copy of HASH object</h3>
<pre>
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello"
set td2 [ns_mhash hash copy $td]
set out [ns_mhash hash end $td]
ns_mhash hash update $td2 " "
ns_mhash hash update $td2 "world"
set out2 [ns_mhash hash end $td2]
ns_adp_puts $out
ns_adp_puts $out2
</pre>
<%
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello"
set td2 [ns_mhash hash copy $td]
set out [ns_mhash hash end $td]
ns_mhash hash update $td2 " "
ns_mhash hash update $td2 "world"
set out2 [ns_mhash hash end $td2]
%>
result out: <%=$out%><br>
result out2: <%=${out2}%>
<br>
<br>
<h3>attach/detach of HASH object</h3>
<pre>
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello"
set detachid [ns_mhash hash detach $td]
nsv_set test test $detachid
set detachid [nsv_get test test]
set td [ns_mhash hash attach $detachid]
ns_mhash hash update $td " "
ns_mhash hash update $td "world"
set out [ns_mhash hash end $td]
ns_adp_puts $out
</pre>
<%
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello"
set detachid [ns_mhash hash detach $td]
nsv_set test test $detachid
set detachid [nsv_get test test]
set td [ns_mhash hash attach $detachid]
ns_mhash hash update $td " "
ns_mhash hash update $td "world"
set out [ns_mhash hash end $td]
%>
result: <%=$out%>
<br>
<br>
<h3>serialize/unserialize of HASH object</h3>
<pre>
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello"
set serializestr [ns_mhash hash serialize $td]
nsv_set test test $serializestr
set serializestr [nsv_get test test]
set td [ns_mhash hash unserialize $serializestr]
ns_mhash hash update $td " world"
set out [ns_mhash hash end $td]
ns_adp_puts $out
</pre>
<%
set td [ns_mhash hash new SHA1]
ns_mhash hash update $td "Hello"
set serializestr [ns_mhash hash serialize $td]
nsv_set test test $serializestr
set serializestr [nsv_get test test]
set td [ns_mhash hash unserialize $serializestr]
ns_mhash hash update $td " world"
set out [ns_mhash hash end $td]
%>
result serialize HASH object: <%=$serializestr%><br>
result: <%=$out%>
<br>
<br>
<h3>hash binary file</h3>
<pre>
set td [ns_mhash hash new MD5]
set fp [open [ns_url2file /docs/test.bin]]
fconfigure $fp -translation binary -encoding binary
while {![eof $fp]} {
    ns_mhash hash update $td [read $fp 1]
}
close $fp
set out [ns_mhash hash end $td]
</pre>
<%
set td [ns_mhash hash new MD5]
set fp [open [ns_url2file /docs/test.bin]]
fconfigure $fp -translation binary -encoding binary
while {![eof $fp]} {
    ns_mhash hash update $td [read $fp 1]
}
close $fp
set out [ns_mhash hash end $td]
%>
result: <%=$out%><br>
expected result: 4bb051067c1f931b6adf55d1161abfac
<br>
<br>

</body>
</html>
