<html>
<head>
<title>Doc :: hmac :: algorithm, generate, ...</title>
</head>
<body>
<a href="../index.adp">up</a><br>
<h1>Hmac</h1>
<h2>Available algorithm</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hmac algorithms</font></tt></td></tr>
<tr><td align="right">result:</td><td>list of available hmac hash algorithms</td></tr>
<tr><td align="right">example:</td><td>[ns_mhash hmac algorithms]=<%=[ns_mhash hmac algorithms]%></td></tr>
</table>

<h2>create new hmac HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hmac new <i>algorithm_name</i> <i>password</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>algorithm_name</i> - name of hash algorithm: MD5, SHA1, ... <br>
<i>password</i> - hmac password
</td></tr>
<tr><td align="right">result:</td><td>hmac HASH object using in other commands</td></tr>
<tr><td align="right">example:</td><td>[ns_mhash hmac new MD5 foobar]</td></tr>
</table>

<h2>destroy hmac HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hmac destroy <i>hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>hash_id</i> - id of hmac HASH object generated by new command (above) </td></tr>
<tr><td align="right">result:</td><td>destroy HASH object without any output</td></tr>
<tr><td align="right">example:</td><td>ns_mhash hmac destroy $hashid</td></tr>
</table>

<h2>end/print hmac HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hmac end ?-bin|-base64? <i>hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td>
<i>hash_id</i> - id of hmac HASH object generated by new command (above)<br>
?-bin|-base64? - type of output format for generated hmac hash string :: default: hexadecimal string; binary (TclByteArray): -bin; binary base64 encoded: -base64<br>
</td></tr>
<tr><td align="right">result:</td><td>return output hmac hash string and destroy hmac HASH object</td></tr>
<tr><td align="right">example:</td><td>set out [ns_mhash hmac end -base64 $hashid]</td></tr>
</table>

<h2>copy hmac HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hmac copy <i>hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>hash_id</i> - id of hmac HASH object generated by new command (above)</td></tr>
<tr><td align="right">result:</td><td>copy of hmac HASH object</td></tr>
<tr><td align="right">example:</td><td>set hashid2 [ns_mhash hmac copy $hashid]</td></tr>
</table>

<h2>update hmac HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hmac update <i>hash_id</i> <i>string</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>hash_id</i> - id of hmac HASH object generated by new command (above)<br>
<i>string</i> - string you want to hash</td></tr>
<tr><td align="right">result:</td><td>update hmac HASH object by string. You can use this repeatedly</td></tr>
<tr><td align="right">example:</td><td>ns_mhash hmac update $hashid "Hello world"</td></tr>
</table>

<h2>detach hmac HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hmac detach <i>hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>hash_id</i> - id of hmac HASH object generated by new command (above)</td></tr>
<tr><td align="right">result:</td><td>detach hmac HASH object from Tcl interpreter. You can you with nsv_* for share hmac HASH object.</td></tr>
<tr><td align="right">example:</td><td>
set detachid [ns_mhash hmac detach $hashid]<br>
nsv_set test test $detachid
</td></tr>
</table>

<h2>attach hmac HASH object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash hmac attach <i>detach_hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>detach_hash_id</i> - detach id of hmac HASH object generated by detach command (above)</td></tr>
<tr><td align="right">result:</td><td>attach hmac HASH object to Tcl interpreter for next using. You can you with nsv_* for share hmac HASH object.</td></tr>
<tr><td align="right">example:</td><td>
set detachid [nsv_get test test]<br>
set hashid [ns_mhash hmac attach $detachid]
</td></tr>
</table>


<h2>Full samples:</h2>
<h3>simple without output</h3>
<pre>
set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello world"
ns_mhash hmac destroy $td
</pre>
<br>
<h3>simple with hash string (base64)</h3>
<pre>
set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello world"
set out [ns_mhash hmac end -base64 $td]
ns_adp_puts $out
</pre>
result: <%
set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello world"
set out [ns_mhash hmac end -base64 $td]
ns_adp_puts $out
%>
<br>
<br>
<h3>simple with hash string (hexadecimal)</h3>
<pre>
set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello world"
set out [ns_mhash hmac end $td]
ns_adp_puts $out
</pre>
result: <%
set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello world"
set out [ns_mhash hmac end $td]
ns_adp_puts $out
%>
<br>
<br>
<h3>copy of HASH object</h3>
<pre>
set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello"
set td2 [ns_mhash hmac copy $td]
set out [ns_mhash hmac end $td]
ns_mhash hmac update $td2 " "
ns_mhash hmac update $td2 "world"
set out2 [ns_mhash hmac end $td2]
ns_adp_puts $out
ns_adp_puts $out2
</pre>
<%
set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello"
set td2 [ns_mhash hmac copy $td]
set out [ns_mhash hmac end $td]
ns_mhash hmac update $td2 " "
ns_mhash hmac update $td2 "world"
set out2 [ns_mhash hmac end $td2]
%>
result out: <%=$out%><br>
result out2: <%=${out2}%>
<br>
<br>
<h3>attach/detach of HASH object</h3>
<pre>
set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello"
set detachid [ns_mhash hmac detach $td]
nsv_set test test $detachid
set detachid [nsv_get test test]
set td [ns_mhash hmac attach $detachid]
ns_mhash hmac update $td " "
ns_mhash hmac update $td "world"
set out [ns_mhash hmac end $td]
ns_adp_puts $out
</pre>
<%
set td [ns_mhash hmac new SHA1 foobar]
ns_mhash hmac update $td "Hello"
set detachid [ns_mhash hmac detach $td]
nsv_set test test $detachid
set detachid [nsv_get test test]
set td [ns_mhash hmac attach $detachid]
ns_mhash hmac update $td " "
ns_mhash hmac update $td "world"
set out [ns_mhash hmac end $td]
%>
result: <%=$out%>
<br>
<br>

</body>
</html>
