<html>
<head>
<title>Doc :: ns_mhash</title>
</head>
<body>
<h1>ns_mhash 1.0</h1>
<h3>Richard Kotal, <a href="mailto:info@waplikace.cz">info@waplikace.cz</a>, <a href="http://www.aolserver.cz">www.aolserver.cz</a></h3>
The module implements interface to mhash library (<a href="http://mhash.sourceforge.net">http://mhash.sourceforge.net</a>).
<br>
The module was tested with 0.9.4 version of mhash library.
<br>
<br>
ns_mhash has three categories of commands:
<ul>
<li><a href="keygen/index.adp">key generator commands</a> - generate key from password (mcrypt,...)</li>
<li><a href="hash/index.adp">hash commands</a> - create hash string from text, data, file, ...</li>
<li><a href="hmac/index.adp">hmac commands</a> - create hmac string from text, data, file, ...</li>
</ul>
<br>
Small samples:
<pre>[ns_mhash keygen create MCRYPT "Hello world" [list MD5] 10]</pre>
result: <%=[ns_mhash keygen create MCRYPT "Hello world" [list MD5] 10]%>
<br>
<br>
<pre>
set td [ns_mhash hash new MD5]
ns_mhash hash update $td "Hello world"
set hash [ns_mhash hash end $td]
ns_adp_puts $hash
</pre>
result: <%
set td [ns_mhash hash new MD5]
ns_mhash hash update $td "Hello world"
set hash [ns_mhash hash end  $td]
ns_adp_puts $hash
%>
<br>
<br>

<pre>
set td [ns_mhash hmac new MD5 "password"]
ns_mhash hmac update $td "Hello world"
set hmac [ns_mhash hmac end -base64 $td]
ns_adp_puts $hmac
</pre>
result: <%
set td [ns_mhash hmac new MD5 "password"]
ns_mhash hmac update $td "Hello world"
set hmac [ns_mhash hmac end -base64 $td]
ns_adp_puts $hmac
%>

</body>
</html>
