<html>
<head>
<title>Doc :: keygen :: algorithm, generate, ...</title>
</head>
<body>
<a href="../index.adp">up</a><br>
<h1>Keygen</h1>
<h2>Available algorithm</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash keygen algorithms</font></tt></td></tr>
<tr><td align="right">result:</td><td>list of available key generator algorithms</td></tr>
<tr><td align="right">example:</td><td>[ns_mhash keygen algorithms]=<%=[ns_mhash keygen algorithms]%></td></tr>
</table>

<h2>algorithm capability</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mhash keygen capability <i>algorithm_name</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>algorithm_name</i> - name of keygen algorithm: HEX, ASIS, S2K_SALTED, ... </td></tr>
<tr><td align="right">result:</td><td>list of capability for <i>algorithm_name</i></td></tr>
<tr><td align="right" valign="top">result description:</td>
<td>
&bull; 0. index of list ([lindex 0 $result]) - <font color="red">1</font> if specified keygen algorithm needs a salt or <font color="red">0</font>.<br>
&bull; 1. index of list ([lindex 1 $result]) - <font color="red">Size of salt</font>. If it is <font color="red">0</font>, then there is no limitation in the size of salt.<br>
&bull; 2. index of list ([lindex 2 $result]) - <font color="red">Maximum size of the key</font>, that the keygen algorithm may produce. If it is <font color="red">0</font>, then there is no limitation in the size.<br>
&bull; 3. index of list ([lindex 3 $result]) - <font color="red">1</font> if the specified keygen algorithm hashs repeatedly the password or <font color="red">0</font>.<br>
&bull; 4. index of list ([lindex 4 $result]) - <font color="red">Number of the hash algorithms</font> the keygen algorithm will use. If it is <font color="red">0</font> then no hash algorithm is used by the keygen algorithm.<br>
</td></tr>
<tr><td align="right">example:</td><td>[ns_mhash keygen capability S2K_SALTED]=<%=[ns_mhash keygen capability S2K_SALTED]%></td></tr>
</table>

<h2>key create</h2>
<table border="1">
<tr><td  valign="top" align="right">command:</td><td><tt><font color="navyblue">ns_mhash keygen create ?-base64|-bin? <i>algorithm_name</i>  <i>password</i> <i>list_of_hash_algorithm_name</i> <i>size_of_output_key</i> <i>?count_of_repeated_hash?</i> <i>?salt_string?</i></font></tt></td></tr>
<tr><td  valign="top" align="right">parameters:</td><td>
?-bin|-base64? - type of output format for generated key :: default: hexadecimal string; binary (TclByteArray): -bin; binary base64 encoded: -base64 <br>
<i>algorithm_name</i> - name of keygen algorithm: HEX, ASIS, S2K_SALTED, ... <br>
<i>password</i> - input string <br>
<i>list_of_hash_algorithm_name</i> - list of hash algorithms used by keygen algorithm <br>
<i>size_of_output_key</i> - size of output generated key <br>
<i>?count_of_repeated_hash?</i> - count how many the keygen algorithm hashs repeatedly the password <br>
<i>?salt_string?</i> - salt used by keygen algorithm <br>

</td></tr>
<tr><td align="right">result:</td><td>key generated by specified keygen algorithm from <i>password</i></td></tr>
<tr><td  valign="top" align="right">example:</td>
<td>
[ns_mhash keygen create -base64 MCRYPT "Hello world" [list MD5] 10 ]=<%=[ns_mhash keygen create -base64 MCRYPT "Hello world" [list MD5] 10 ]%><br/>
[ns_mhash keygen create  MCRYPT "Hello world" [list MD5] 10 ]=<%=[ns_mhash keygen create  MCRYPT "Hello world" [list MD5] 10 ]%><br>
[ns_mhash keygen create  S2K_SALTED "Hello world" [list SHA1] 20  0 "salt"]=<%=[ns_mhash keygen create  S2K_SALTED "Hello world" [list SHA1] 20 0 "salt"]%>
</td></tr>
</table>

</body>
</html>
